<?php

class PagePositionMapper
{
    /**
     * PagePositionMapper constructor.
     *
     * This class cannot be instantiated
     */
    private function __construct()
    {
    }
    
    
    /**
     * The position inside the json file differs from the actually needed one
     * in the Database. This method translates the position
     *
     * @param \StringType $position
     *
     * @return string
     * @throws \Exception
     */
    public static function getPagePositionForDatabase(StringType $position)
    {
        switch ($position->asString()) {
            case 'info':
                
                return 'pages_info';
            
            case 'mainNavigation' :
                
                return 'pages_main';
            
            case 'infoBox' :
                
                return 'pages_info_box';
            
            case 'secondaryNavigation' :
                
                return 'pages_secondary';
            
            default:
                
                throw new Exception('Unknown PagePosition(' . $position->asString() . ')');
        }
    }
}